if(OS_ANDROID){
	var abx = require('com.alcoapps.actionbarextras');
	var TiDrawerLayout = require('com.tripvi.drawerlayout');
} 

var defaultLeftWidth = (!Alloy.isTablet) ? "280dp" : "25%";
var centerViewTabletWidth = "75%";
var menuContainer = null;
//var hasMenu = false, hasSlide = false;
var selected;

//FOR TABLET
var centerViewTablet = null;

/**
 * initializes drawer navigation
 */
exports.initDrawer = function(windowToAttach, centerController, windowType, hasDrawer, title, subtitle) {
	Alloy.Globals.notifiche = true;
	
	if (hasDrawer) {		
		menuContainer = Alloy.createController('drawer/menuContainer', {
			parent : windowToAttach
		});
					
		// this is just a wrapper
		// actual content views are add to this later
		Alloy.Globals.contentView = Ti.UI.createView({
		 	width : (!Alloy.isTablet) ? Ti.UI.FILL : centerViewTabletWidth,
		   	height : Ti.UI.FILL
		});
		
		//TABLET
		if(Alloy.isTablet){
			Alloy.Globals.drawer = menuContainer.getView();
	        Alloy.Globals.drawer.width = defaultLeftWidth;
	        Alloy.Globals.drawer.left = 0;
			
			Alloy.Globals.contentView.right = 0;
            windowToAttach.add(Alloy.Globals.contentView);
		//SMARTPHONE
		}else {		
			Alloy.Globals.drawer = TiDrawerLayout.createDrawer({
				leftView : menuContainer.getView(),
			    centerView : Alloy.Globals.contentView,
			    leftDrawerWidth : defaultLeftWidth,
			    drawerArrowIcon : true
			});
		}   
			
		Alloy.Globals.contentView.add(centerController.getView());
				
		windowToAttach.add(Alloy.Globals.drawer);
		initDrawerBheaviour(windowToAttach, windowType);
		init(windowToAttach, centerController, windowType, hasDrawer, title, subtitle);
	}else init(windowToAttach, centerController, windowType, hasDrawer, title, subtitle);
}

/**
 * 
 */
function init(windowToAttach, centerController, windowType, hasDrawer, title, subtitle) {
    var activity = windowToAttach.activity;
    
    // set initial values
	abx.title = title || "XeniaSoft";
	abx.titleFont = Alloy.Globals.font + ".ttf";
	abx.titleColor = Alloy.Globals.navTitleColor;
	abx.backgroundColor = Alloy.Globals.navBgColor;
	abx.subtitle = null;	
	
	if(activity){
		var actionBar = activity.getActionBar();
	
		activity.onCreateOptionsMenu = function(e){
		    if(actionBar){
		    	actionBar.displayHomeAsUp = true;
		    	
		        if(hasDrawer){
		        	if(!Alloy.isTablet){
			        	activity.actionBar.onHomeIconItemSelected = function() {
			              	if(Alloy.Globals.drawer.isRightDrawerOpen) Alloy.Globals.drawer.toggleRightWindow(); 
			               	Alloy.Globals.drawer.toggleLeftWindow();                	
			           	};
			    	}else actionBar.displayHomeAsUp = false;
		        }else {
				  	activity.actionBar.onHomeIconItemSelected = function() {
				   		windowToAttach.fireEvent('android:back');
				    };
				    		
				    if("elenco_prenotazioni" == windowToAttach.id){
						var menu = e.menu;
						
						var del = menu.add({
							title : "Delete",
							itemId : 1,
							showAsAction : Ti.Android.SHOW_AS_ACTION_IF_ROOM
						});
				
						del.setIcon("images/ic_delete_white_24dp.png");
						del.addEventListener("click", function(e) {
							Ti.App.fireEvent('delete_prenotazioni');
						});
					}
				}	      	
		  	} 
		};	
      	
    	activity.invalidateOptionsMenu();	     
	}
};

/**
 * Select menu by row
 * @param {controllers.menuRow} Row
 */
function selectRow(_currentWindow, _row) {
  	selected = _row;
  	
  	//_.defer(function() {
    	Alloy.Globals.open(Alloy.createController('list/' + _row.id, {
      		parent : _currentWindow
    	}));
  	//});
}

/**
 *Iniziliazzo il comportamento del drawer
 *
 * @param {Object} drawer
 */
function initDrawerBheaviour(currentWindow, drawer, windowType) {    
    //TABLET
    var sidebar = Alloy.Globals.drawer.leftView;
    if(Alloy.isTablet){
        sidebar = Alloy.Globals.drawer;
    }
    
    _.each(sidebar.getSections(), function(section) {
        _.each(section.rows, function(row) {
        	row.addEventListener('click', function(e) { 
            	Alloy.Globals.loading.show('Please wait...', false);
            	         
                //SMARTPHONE
                if(!Alloy.isTablet){
                    Alloy.Globals.drawer.toggleLeftWindow();
                }     
                
                if(!Alloy.isTablet) var delay = 280;
                else{
                	var delay = 0;
                	row.backgroundColor = Alloy.Globals.defaultDetailsBgColor;
                
	                setTimeout(function(){
	                	row.backgroundColor = 'transparent';
	                }, 50);
                } 
                
                switch(row.type) {                	
                    case Alloy.Globals.WINDOW_TYPE.LIST : 
                    	abx.titleFont = Alloy.Globals.fontTitle + ".ttf";
	                	    
					   	if (row !== selected) {
					   		setTimeout(function(){		
					   			selectRow(currentWindow, row);
					   		}, 300);	
					   				    	
					    	abx.title = L(row.itemTitleId);
					    	if(row.id != "news" && row.id != "eventi" && row.id != "promozioni" && row.id != "corsi" && row.id != "elenco_prenotazioni"){	
					    		currentWindow.activity.onCreateOptionsMenu = function(e) {
									menu = e.menu;
									menu.clear();
								}				    		
	                           	
	                           	currentWindow.activity.invalidateOptionsMenu();
	                        }			    			    	
					  	}else Alloy.Globals.loading.hide();
					  	
                        //se sono in una lista apro la vista centrale altrimenti apro un'altra finestra
                        //var newList = Alloy.createController("list/" + row.id).getView();
                        //TABLET
                        /*if(Alloy.isTablet){                        	
                            currentWindow.remove(centerViewTablet);                                           
                            newList.width = Alloy.Globals.centerViewTabletWidth;
                            newList.right = 0;
                            centerViewTablet = newList;
                            currentWindow.add(newList);                                
                       	}else{
                            drawer.centerView = newList;
                            currentWindow.activity.actionBar.title = L(row.itemTitleId);
                        }*/

                        break;
                    case Alloy.Globals.WINDOW_TYPE.FEATURE :
                    	hasMenu = false;
                        
                    	setTimeout(function(){
                        	Alloy.createController("features/"+row.id).getView().open();
                        }, delay);
                        break;
                    case Alloy.Globals.WINDOW_TYPE.CONTENT :
                    	hasMenu = false;
                       
						setTimeout(function(){
                        	Alloy.createController("info/"+row.id).getView().open();
                        }, delay);
                        
                        break;
                    default:
                        Alloy.createController("info/contatti",{
                             alloyId: row.alloyId
                        }).getView().open();
                        break;
                };
            });
        });
    });
}

/**
 *Iniziliazzo il comportamento del drawer per iOS
 */

exports.initIOSDrawerBheaviour = function(sidebar) {
    _.each(sidebar.getSections(), function(section) {
        _.each(section.rows, function(row) {
            row.addEventListener('click', function(e) {                
                switch(row.type) {
                    case Alloy.Globals.WINDOW_TYPE.LIST :                        
                        var newList = Alloy.createController("list/" + row.id).getView();
                        //TABLET
                        if(Alloy.isTablet){
                        	Alloy.Globals.mainWindow.remove(Alloy.Globals.mainWindow.children[0]);  
                            Alloy.Globals.mainWindow.add(newList);
                            
                            if(row.id != "news" && row.id != "eventi" && row.id != "promozioni" && row.id != "corsi"){
	                            var details = Ti.UI.createLabel({
								    text: L("drawer_" + row.id + "_title"),
								    color: Alloy.Globals.navTitleColor,
									font: {
										fontFamily: Alloy.Globals.fontIOS,
										fontSize: Alloy.Globals.H2Size
									}
								});
								
								Alloy.Globals.containerWindow.setRightNavButton(details);
							}						
                        }else{
                        	var fn = 'toggleLeftWindow';
	    					Alloy.Globals.drawer[fn]();
	    					
	    					Alloy.Globals.mainWindow = Ti.UI.iOS.createNavigationWindow({window:newList});
	    				
                            Alloy.Globals.drawer.setCenterWindow(Alloy.Globals.mainWindow);
                        }                        
                        break;
                    case Alloy.Globals.WINDOW_TYPE.FEATURE:                    	
                    	var featureWindow = Alloy.createController("features/"+row.id);
                    	
                    	if(!Alloy.isTablet){
                    		var fn = 'toggleLeftWindow';
	    					Alloy.Globals.drawer[fn]();
	    					
		    				Alloy.Globals.mainWindow.openWindow(featureWindow.getView(), {
	                        	animated:true
	                        });
	                    }else{
	                    	Alloy.Globals.index.openWindow(featureWindow.getView(), {
	                        	animated:true
	                        });
	                    }
                        break;
                    case Alloy.Globals.WINDOW_TYPE.CONTENT :
                        var newContent = Alloy.createController("info/" + row.id).getView();
                        //TABLET
                        if(Alloy.isTablet){
                        	Alloy.Globals.index.openWindow(newContent, {
	                        	animated:true
	                        });
                        }else{
                        	var fn = 'toggleLeftWindow';
	    					Alloy.Globals.drawer[fn]();
	    					
	    					Alloy.Globals.mainWindow = Ti.UI.iOS.createNavigationWindow({window:newContent})
	    				
                            Alloy.Globals.drawer.setCenterWindow(Alloy.Globals.mainWindow);
                        }
                        break;
                    default:
                        break;
                };
            });
        });
    });
}


/** 
 * libero le risorse di una finestra alla chiusura
 *
 * @param {Object} currentWindow
 */
exports.closeWindow = function(currentWindow) {     
    if(currentWindow != null){
        currentWindow.close();
        currentWindow = null;
    }
};