exports.checkRemoteImage = function(img_url, callback){
	var xhr = Ti.Network.createHTTPClient({
        onerror : function() {
            callback.error();
        },

        onload : function() {      
            callback.success();
        }
    });
    
    xhr.open("GET", img_url);
    xhr.send();
};

exports.getGornoSettimana = function(day) {
    if(day == 1) var giorno = L('Domenica');
	if(day == 2) var giorno = L('Lunedì');
	if(day == 3) var giorno = L('Martedì');
	if(day == 4) var giorno = L('Mercoledì');
	if(day == 5) var giorno = L('Giovedì');
	if(day == 6) var giorno = L('Venerdì');
	if(day == 7) var giorno = L('Sabato');

    return giorno;
};

exports.getDate = function(day, week) {
	var d = new Date();
	
	switch (d.getDay())
	{
		case 0: d.setDate(d.getDate() + (day - 1) + (7 * week));
		break;
						
		case 1: d.setDate(d.getDate() + (day - 2) + (7 * week));
		break;
							
		case 2: d.setDate(d.getDate() + (day - 3) + (7 * week));
		break;
							
		case 3: d.setDate(d.getDate() + (day - 4) + (7 * week));
		break;
							
		case 4: d.setDate(d.getDate() + (day - 5) + (7 * week));
		break;
		
		case 5: d.setDate(d.getDate() + (day - 6) + (7 * week));
		break;
							
		case 6: d.setDate(d.getDate() + (day - 7) + (7 * week));
		break;
	}
    
    return d;
};

/**
 * ritorna il nome del file partendo dal path passato
 */
exports.getFilename = function(filepath) {
	var filepath = Ti.Network.decodeURIComponent(filepath);
    var filename = filepath.replace(/.*[\/\\]([^\/\\]+$)/, "$1");
    filename = filename.split("?", 1);
    filename = filename[0];
    
    return filename;
};

exports.retrieveFile = function(filepath, imageDirectoryName, callback) {
	var file = Ti.Filesystem.getFile(Ti.Filesystem.applicationDataDirectory, imageDirectoryName, exports.getFilename(filepath));
	
	if(file.exists() == false) {
		var dm = require('downloadManager');
		
		dm.downloadSingleFile(imageDirectoryName,filepath,callback);
	}else{
		callback.success();
	}
};

exports.toHHMMSS = function (value) {
    var sec_num = parseInt(value); // don't forget the second param
    var hours   = Math.floor(sec_num / 3600);
    var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
    var seconds = sec_num - (hours * 3600) - (minutes * 60);

    if (minutes < 10) {minutes = "0"+ minutes;}
    if (seconds < 10) {seconds = "0" + seconds;}
    
    return minutes + ':' + seconds;
};

