var Mutators = require('vendor/backbone.mutators');
var utils = require('ui/utils');

exports.definition = {
    config : {        
        URL: "http://myclubmanager.azurewebsites.net/api/Corsi/?id=456726",
    	debug: 0, //debug mode enabled
    	useStrictValidation: 0, // validates each item if all columns are present
        adapter : {
            type : "sqlrest",
            collection_name : "corsi",
            db_file : "/xeniasoft.sqlite",
            db_name : "xeniasoft",
            //idAttribute: "rowid",
            remoteBackup : false            
        },        
   	 	initFetchWithLocalData : false,
    	disableSaveDataLocallyOnServerError : true,
    	localOnly: false,
    	deleteAllOnFetch: true,
    	parentNode: function (data) {
    		return JSON.parse(data);
		}
    },

    extendModel: function(Model) {		
        _.extend(Model.prototype, {
            // Extend, override or implement Backbone.Model 
            mutators : {                
                titolo : {
                    get : function() {
                        return "   " + this.get("corso") + "   ";
                    }, // get
                    transient : true
                },
                trainer : {
                    get : function() {
                        return L('istruttore') + this.get("istruttore").toUpperCase() + "   ";
                    }, // get
                    transient : true
                },
                image : {
                    get : function() {
                        return (this.get("foto") != "") ? this.get("foto") : "/images/placeholder_big.jpg";
                    }, // get
                    transient : true
                },
                imageList : {
                    get : function() {
                        return (this.get("foto") != "") ? this.get("foto") : "/images/placeholder.jpg";
                    }, // get
                    transient : true
                }
            }
        });
		
        return Model;
    },

    extendCollection: function(Collection) {		
        _.extend(Collection.prototype, {
            // Extend, override or implement Backbone.Collection 
			getCorso : function(id) {
				var collection = this;
				
				var sql = "SELECT * FROM " + collection.config.adapter.collection_name + " WHERE id_corso=" + id;
				db = Ti.Database.open(collection.config.adapter.db_name);
				var rs = db.execute(sql);
				var output = [];
				if(rs.isValidRow()) {
					output.push({
						imageList: (rs.fieldByName("foto") != "") ? rs.fieldByName("foto") : "/images/placeholder.jpg" ,
						corso : rs.fieldByName("corso"),
						descrizione : rs.fieldByName("descrizione"),
						istruttore: rs.fieldByName("istruttore"),
						sala : rs.fieldByName("sala"),
						prenotabile : rs.fieldByName("prenotabile")
					});
				}
				
				rs.close();
				db.close();
				
				return output;
			}
        });
		
        return Collection;
    }
};
